	.NOLIST
	comment 
/*****************************************************************************
*
*      Sample program to demonstrate how a program can display a
*      "Send To" menu and send documents to items thereon.
*      Overview
*
*      This sample program illustrates the following points:
*
*      -   Enumerating the contents of the "Send To" folder.
*
*      -   Obtaining the IDataObject interface for a file.
*
*      -   Obtaining the IDropTarget for a shell extension.
*
*      -   Dropping a file onto an item thus enumerated.
*
*****************************************************************************/

/*****************************************************************************
*
*      Notes
*
*      Since this program is written in C, invoking OLE methods is
*      done via
*
*          p->lpVtbl->MethodName(p, arg, arg)
*
*      To convert this program to C++, the code that invokes OLE
*      methods should be changed to
*
*          p->MethodName(arg, arg)       ;used by the COM MACRO  (best is Iinterface MACRO)
*							;DECLARE_pdto TEXTEQU <STIDataObject>
*      just like any other C++ method.
*
*      For example,
*
*          peidl->lpVtbl->Release(peidl);
*
*      becomes
*
*          peidl->Release();
*
*      Also, REFIID parameters in C are passed as
*
*          &IID_IName
*
*      but they are passed in C++ as
*
*          IID_IName
*
*      Therefore,
*
*          hres = g_psfDesktop->lpVtbl->BindToObject(g_psfDesktop,
*                      pidl, NULL, &IID_IShellFolder, (LPVOID *)&psf);
*
*      becomes
*
*          hres = g_psfDesktop->BindToObject(
*                      pidl, NULL, IID_IShellFolder, (LPVOID *)&psf);
*
*****************************************************************************/





; Listing generated by Microsoft (R) Optimizing Compiler Version 16.00.30319.01 

	TITLE	C:\Program Files\Microsoft SDKs\Windows\v7.1\Samples\winui\sendto\sendto.c
	.686P
	.XMM
	;include listing.inc
	.model	flat,stdcall
	option casemap :none   ; case sensitive	
.const
IDM_OPEN     equ        00100h
IDM_SENDTOPOPUP   equ      00101h

IDM_SENDTOFIRST   equ      00200h
IDM_SENDTOLAST   equ       002FFh

STRICT equ
_INC_STDIO_WIN equ ;
	include translate.inc
	include \vc\stdio.sdk ;more uptodate files com first	
	include windows.sdk
	;include windowsx.sdk
	include shlobj.sdk
	include shlwapi.sdk
	include strsafe.sdk     
	include commdlg.sdk
	include macros.inc
;StringCopyWorker _StringCopyWorkerA@12
INCLUDELIB MSVCRTD
INCLUDELIB OLDNAMES
INCLUDELIB \WinDDK\6001.18001\lib\wxp\i386\strsafe.lib ;
INCLUDELIB shlwapi.lib

GetSpecialFolder	PROTO  C  :DWORD,:DWORD     
ChaineCchCopyA     PROTO  stdcall  :DWORD,:DWORD,:DWORD
ChaineCchPrintfA   PROTO  C  :DWORD,:DWORD,:DWORD
ChaineValidateDestA PROTO  stdcall  :DWORD,:DWORD,:DWORD
ChaineVPrintfWorkerA 	PROTO  stdcall  :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
ChaineCopyWorker PROTO  :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
.data        
g_hmenuSendTo dd 0
ppvIShellFolder dd 0
g_szFileName BYTE MAX_PATH dup (0)
g_hinst dd 0          
$SG120062 DB	0
	ALIGN	4
$SG120080 DW	0
$SG120552 DB	'(none)', 00H
	ORG $+1
$SG120572 DB	'%s - SendTo Demo', 00H
	ORG $+3
$SG120658 DB	'SendToMenu', 00H
	ORG $+1
$SG120659 DB	'SendTo', 00H
	ORG $+1
$SG120687 DB	'SendTo Demo', 00H
$SG120688 DB	'SendTo', 00H 
IID_IShellFolder GUID <0214E6H,0H,0H,<0C0H,0H,0H,0H,0H,0H,0H,046H>>
IID_IDropTarget GUID <0122H,0H,0H,<0C0H,0H,0H,0H,0H,0H,0H,046H>>
IID_IDataObject GUID <010EH,0H,0H,<0C0H,0H,0H,0H,0H,0H,0H,046H>>
;17 138
; E:\vc\stdio.sdk
; vsnprintf

DECLARE_ppvIShellFolder TEXTEQU <STIShellFolder> 
DECLARE_Isfolder TEXTEQU <STIShellFolder> 
DECLARE_pidl TEXTEQU <ITEMIDLIST>
DECLARE_IDropT TEXTEQU <STIDropTarget>
DECLARE_peidl TEXTEQU <STIEnumIDList>
DECLARE_pdto TEXTEQU <STIDataObject>

.code
GetSpecialFolder	PROC  C  uses esi edi ebx hwnd:DWORD,idFolder:DWORD
		LOCAL pidl:DWORD,hres:SDWORD,Isfolder:DWORD
		
	invoke SHGetSpecialFolderLocation,hwnd,CSIDL_SENDTO,addr pidl
	.if eax == NOERROR
		IShellFolder BindToObject,pidl, NULL, addr IID_IShellFolder,addr Isfolder
		.if eax == S_OK
		.else
			mov	Isfolder , 0	
		.endif
		invoke CoTaskMemFree,pidl				
	.else
		mov	Isfolder , 0 			
	.endif
	return Isfolder
GetSpecialFolder ENDP



PidlFromPath	PROC  C  uses esi edi ebx hwnd:DWORD,pszPath:DWORD
		LOCAL pidl:DWORD,ulEaten:DWORD,hres:SDWORD,wszName[MAX_PATH]:WORD
		LOCAL dwAttributes:DWORD
	IFDEF UNICODE
		invoke StringCchCopy,addr wszName, LENGTHOF wszName, pszPath
		.if FAILED
			return NULL
		.endif

	ELSE
		invoke MultiByteToWideChar,CP_ACP,0,pszPath,-1,addr wszName ,LENGTHOF wszName
		.if eax == 0
			return NULL
		.endif
	ENDIF		
	IShellFolder ParseDisplayName,hwnd,NULL,addr wszName, addr ulEaten,addr pidl,addr dwAttributes
	.if eax != S_OK
		return NULL
	.else	
		return pidl
	.endif

PidlFromPath ENDP

comment 
/*****************************************************************************
*
*  GetUIObjectOfAbsPidl
*
*      Given an absolute (desktop-relative) LPITEMIDLIST, get the
*      specified UI object.
*
*****************************************************************************/



GetUIObjectOfAbsPidl	PROC  C  uses esi edi ebx hwnd:DWORD,pidl:DWORD,riid:DWORD,ppvOut:DWORD
		LOCAL hres:SDWORD,Isfolder:DWORD,pidlLast:DWORD
	mov	eax,ppvOut 
	mov	DWORD PTR [eax], 0
	lea	eax,Isfolder
	mov	DWORD PTR [eax], 0	
	lea	eax, pidlLast
	mov	DWORD PTR [eax], 0		
	;
	;  Bind to the parent folder of the item we are interested in.
	;api	pidl ok
	
	invoke	SHBindToParent,pidl,addr IID_IShellFolder,addr Isfolder ,addr pidlLast 
	mov	hres , eax 
		.if eax != S_OK
	;
	;  Couldn't even get to the parent; we have no chance of
	;  getting to the item itself.
	;
	return hres
	.endif
	;
	;  Now ask the parent for the the UI object of the child.
	;
	COM Isfolder,GetUIObjectOf, hwnd, 1,addr pidlLast,riid, NULL, ppvOut	
	;
	;  Regardless of whether or not the GetUIObjectOf succeeded,
	;  we have no further use for the parent folder.
	;	
	COM Isfolder,Release
	
	return hres 
GetUIObjectOfAbsPidl ENDP

comment 
/*****************************************************************************
*
*  GetUIObjectOfPath
*
*      Given an absolute path, get its specified UI object.
*
*****************************************************************************/


GetUIObjectOfPath	PROC  C  uses esi edi ebx hwnd:DWORD,pszPath:DWORD,riid:DWORD,ppvOut:DWORD
		LOCAL pidl:DWORD,hres:DWORD
	mov	eax,ppvOut 
	mov	DWORD PTR [eax], 0
	invoke	PidlFromPath,hwnd,pszPath
	mov	pidl , eax 
	.if	pidl != 0 
		invoke	GetUIObjectOfAbsPidl,hwnd,pidl,riid,ppvOut
		mov	hres , eax 
		invoke	CoTaskMemFree,pidl
		mov	eax,hres 
	.else
		return E_FAIL	
	.endif	
	ret  
GetUIObjectOfPath ENDP



DoDrop	PROC  C  uses esi edi ebx pdto:DWORD,IDropT:DWORD
		LOCAL hres:SDWORD,pt:POINTL,dwEffect:DWORD

	;
	;  The data object enters the drop target via the left button
	;  with all drop effects permitted.
	;		
	mov	DWORD PTR pt[0] , 0 
	mov	DWORD PTR pt [+4], 0 
	mov	dwEffect ,DROPEFFECT_COPY OR DROPEFFECT_MOVE OR DROPEFFECT_LINK
	COM IDropT,DragEnter, pdto, MK_LBUTTON, pt, addr dwEffect
	
	.if eax == S_OK && dwEffect != 0
	;*  The drop target likes the data object and the effect.
	;*  Go drop it.
		COM IDropT,Drop,pdto, MK_LBUTTON, pt, addr dwEffect
		mov hres,eax
	.else
	;*  The drop target didn't like us.  Tell it we're leaving,
	;*  sorry to bother you.		
		COM IDropT,DragLeave
		mov hres,eax	
	.endif
	.LISTALL
	return hres
	.NOLIST
DoDrop	ENDP
comment 
/*****************************************************************************
*
*  SendTo_OnCreate
*
*      When we are created, remember the handle of our SendTo menu
*      so we can recognize it later.
*
*****************************************************************************/


SendTo_OnCreate	PROC  C  uses esi edi ebx hwnd:DWORD,lpCreateStruct:DWORD
		LOCAL mii:MENUITEMINFO,hmenu:DWORD
	mov	DWORD PTR mii.cbSize, sizeof mii 
	mov	DWORD PTR mii.fMask,MIIM_SUBMENU 
	invoke	GetMenu,hwnd
	mov	hmenu , eax 
	invoke	GetMenuItemInfoA,hmenu,IDM_SENDTOPOPUP,0,addr mii
	.if eax != 0
		PuPo g_hmenuSendTo,mii.hSubMenu
	.endif
	mov	eax, 1
	ret  
SendTo_OnCreate ENDP

SendTo_ResetSendToMenu	PROC  C  uses esi edi ebx hmenu:DWORD
		LOCAL mii:MENUITEMINFO
	mov	mii.cbSize,sizeof mii
	mov	 mii.fMask,MIIM_DATA
	@@:
	invoke	GetMenuItemInfoA,hmenu,0,1,addr mii
	.if eax != 0
		.if mii.dwItemData != 0
			invoke	CoTaskMemFree,mii.dwItemData
		.endif
		invoke DeleteMenu,hmenu, 0, MF_BYPOSITION
		jmp @B
	.endif
	ret  
SendTo_ResetSendToMenu ENDP
comment 
/*****************************************************************************
*
*  SendTo_FillSendToMenu
*
*      Enumerate the contents of the SendTo folder and fill the
*      menu with the items therein.
*
*****************************************************************************/


SendTo_FillSendToMenu	PROC  C  uses esi edi ebx hwnd:DWORD,hmenu:DWORD
		LOCAL pszName:DWORD,peidl:DWORD,strret:STRRET,pidl:DWORD,hres:SDWORD
		LOCAL idm:DWORD,mii:MENUITEMINFO,Isfolder:DWORD
		ZEROLOCALES
		
	mov	idm , IDM_SENDTOFIRST		
	invoke	GetSpecialFolder,hwnd,CSIDL_SENDTO
	mov	Isfolder , eax 
	.if Isfolder != 0
		COM Isfolder,EnumObjects1,hwnd,SHCONTF_FOLDERS OR SHCONTF_NONFOLDERS,addr peidl
		.if eax == S_OK
			newmenu:
			COM peidl,Next,1,addr pidl, NULL	
			.if eax == S_OK
				COM Isfolder,GetDisplayNameOf,pidl,SHGDN_NORMAL, addr strret
				invoke StrRetToStr,addr strret,pidl,addr pszName
				.if eax == S_OK
					mov eax,pszName
					invoke AppendMenu,hmenu, MF_ENABLED OR MF_STRING,idm, pszName
					.if eax != 0
						PuPo mii.cbSize,sizeof mii
						PuPo mii.fMask,MIIM_DATA
						PuPo mii.dwItemData,pidl
						invoke SetMenuItemInfo,hmenu,idm,FALSE,addr mii
						inc idm
					.endif
					invoke CoTaskMemFree,pszName
				.endif
				.if idm < IDM_SENDTOLAST
					jmp newmenu
				.endif
			.else
				COM peidl,Release
			.endif
			COM Isfolder,Release
		.endif
	.endif
	;*  If the menu is still empty (the user has an empty SendTo folder),
	;*  then add a disabled "None" item so we have at least something
	;*  to display.
	.if idm == IDM_SENDTOFIRST  ;aucun menu crer 
	invoke AppendMenu,hmenu, MF_GRAYED OR MF_DISABLED OR MF_STRING,idm,SADR("none")
	.endif
	
	ret  
SendTo_FillSendToMenu ENDP

comment 
/*****************************************************************************
*
*  SendTo_OnInitMenuPopup
*
*      When the SendTo menu pops up, enumerate the contents of the
*      SendTo folder and populate the menu.
*
*****************************************************************************/


SendTo_OnInitMenuPopup	PROC  C  uses esi edi ebx hwnd:DWORD,hmenu:DWORD,item:DWORD,fSystemMenu:DWORD
; Line 412  **    if (hmenu == g_hmenuSendTo) {
	mov	eax,hmenu 
	cmp	eax, DWORD PTR g_hmenuSendTo 
	jne	SHORT $LN2@SendTo_OnI
	invoke	SendTo_ResetSendToMenu,hmenu
	invoke	SendTo_FillSendToMenu,hwnd,hmenu
$LN2@SendTo_OnI:
	ret  
SendTo_OnInitMenuPopup ENDP

comment 
/*****************************************************************************
*
*  SendTo_OnOpen
*
*      "Open" a file.  Just get its name and save it in our global
*      g_szFileName variable.  (And update the title too, just to
*      look pretty.)
*
*****************************************************************************/




SendTo_OnOpen	PROC  C  uses esi edi ebx hwnd:DWORD
		LOCAL ofn:OPENFILENAME,szTitle[64]:BYTE,szFileName[MAX_PATH]:BYTE
		
	invoke	memset,addr ofn ,0,sizeof ofn
	mov	ofn.lStructSize,sizeof ofn		; 00000058H lStructSize
	mov	ecx,hwnd 
	mov	DWORD PTR ofn.hwndOwner, ecx 
	;invoke	ChaineCchCopyA,addr szFileName,sizeof szFileName,addr g_szFileName ;g_szFileName BYTE 0104H dup (0)
	invoke lstrcpy,addr szFileName,addr g_szFileName
	lea	eax, szFileName
	mov	DWORD PTR ofn.lpstrFile , eax 
	mov	DWORD PTR ofn.nMaxFile, sizeof szFileName		; 00000104H 
	lea	ecx, szTitle
	mov	DWORD PTR ofn.lpstrFileTitle, ecx 
	mov	DWORD PTR ofn.nMaxFileTitle, sizeof szTitle	; 00000040H 
	mov	DWORD PTR ofn.Flags,OFN_FILEMUSTEXIST OR OFN_HIDEREADONLY OR OFN_PATHMUSTEXIST
	invoke	GetOpenFileName,addr ofn 
	test	eax, eax
	je	SHORT $LN2@SendTo_OnO
	invoke lstrcpy,addr g_szFileName,addr szFileName
	;invoke	ChaineCchCopyA,addr g_szFileName,260,addr DWORD PTR szFileName
	invoke	StringCchPrintf,addr szFileName ,260,addr $SG120572,addr szTitle 
	invoke	SetWindowText,hwnd,addr szFileName 
$LN2@SendTo_OnO:
	ret  
SendTo_OnOpen ENDP
;	COMDAT _ChaineCchCopyA@12


ChaineCchCopyA	PROC  stdcall  uses esi edi ebx pszDest:DWORD,cchDest:DWORD,pszSrc:DWORD
		LOCAL hr:SDWORD
	;invoke	ChaineValidateDestA,pszDest,cchDest,2147483647
	;mov	hr , eax 
; Line 468  **    LPDATAOBJECT pdto;
	;cmp	hr , 0 
	;jl	SHORT $LN1@StringCchC
	invoke	ChaineCopyWorker,pszDest,cchDest,0,pszSrc,2147483646
	mov	hr , eax 
$LN1@StringCchC:
; Line 477  **
	mov	eax,hr 
	ret                   
ChaineCchCopyA ENDP



ChaineCchPrintfA	PROC  C  uses esi edi ebx pszDest:DWORD,cchDest:DWORD,pszFormat:DWORD
		LOCAL argList:DWORD,hr:SDWORD
	lea	edx, DWORD PTR pszFormat [+4] 
	mov	argList , edx       
	invoke	ChaineVPrintfWorkerA,pszDest,cchDest,0,pszFormat,argList
	mov	hr , eax 
; Line 4565  **    if (SUCCEEDED(hres)) {
	mov	argList , 0       
$LN1@StringCchP:
; Line 4568  **    if (SUCCEEDED(hres)) {
	mov	eax,hr 
	ret  
ChaineCchPrintfA ENDP


ChaineCopyWorker PROC _cchToCopy$:DWORD,_pszSrc$,_pcchNewDestLength$,_cchDest$,_pszDest$
	Local _cchNewDestLength$:DWORD,_hr$
; Line 8948  **    if (SUCCEEDED(hres)) {
	mov	DWORD PTR _hr$, 0
; Line 8949  **    if (SUCCEEDED(hres)) {
	mov	DWORD PTR _cchNewDestLength$, 0
$LN4@StringCopy:
; Line 8953  **    if (SUCCEEDED(hres)) {
	cmp	 _cchDest$, 0
	je	SHORT $LN3@StringCopy
	cmp	_cchToCopy$, 0
	je	SHORT $LN3@StringCopy
	mov	eax, DWORD PTR _pszSrc$
	movsx	ecx, BYTE PTR [eax]
	test	ecx, ecx
	je	SHORT $LN3@StringCopy
; Line 8955  **    if (SUCCEEDED(hres)) {
	mov	edx, DWORD PTR _pszDest$
	mov	eax, DWORD PTR _pszSrc$
	mov	cl, BYTE PTR [eax]
	mov	BYTE PTR [edx], cl
	mov	edx, DWORD PTR _pszDest$
	add	edx, 1
	mov	DWORD PTR _pszDest$, edx
	mov	eax, DWORD PTR _pszSrc$
	add	eax, 1
	mov	DWORD PTR _pszSrc$, eax
; Line 8956  **    if (SUCCEEDED(hres)) {
	mov	ecx, DWORD PTR _cchDest$
	sub	ecx, 1
	mov	DWORD PTR _cchDest$, ecx
; Line 8957  **    if (SUCCEEDED(hres)) {
	mov	edx, DWORD PTR _cchToCopy$
	sub	edx, 1
	mov	DWORD PTR _cchToCopy$, edx
; Line 8959  **    if (SUCCEEDED(hres)) {
	mov	eax, DWORD PTR _cchNewDestLength$
	add	eax, 1
	mov	DWORD PTR _cchNewDestLength$, eax
; Line 8960  **    if (SUCCEEDED(hres)) {
	jmp	SHORT $LN4@StringCopy
$LN3@StringCopy:
; Line 8962  **    if (SUCCEEDED(hres)) {
	cmp	DWORD PTR _cchDest$, 0
	jne	SHORT $LN2@StringCopy
; Line 8965  **    if (SUCCEEDED(hres)) {
	mov	ecx, DWORD PTR _pszDest$
	sub	ecx, 1
	mov	DWORD PTR _pszDest$, ecx
; Line 8966  **    if (SUCCEEDED(hres)) {
	mov	edx, DWORD PTR _cchNewDestLength$
	sub	edx, 1
	mov	DWORD PTR _cchNewDestLength$, edx
; Line 8968  **    if (SUCCEEDED(hres)) {
	mov	DWORD PTR _hr$, -2147024774	; 8007007aH
$LN2@StringCopy:
; Line 8971  **    if (SUCCEEDED(hres)) {
	mov	eax, DWORD PTR _pszDest$
	mov	BYTE PTR [eax], 0
; Line 8973  **    if (SUCCEEDED(hres)) {
	cmp	DWORD PTR _pcchNewDestLength$, 0
	je	SHORT $LN1@StringCopy
; Line 8975  **    if (SUCCEEDED(hres)) {
	mov	ecx, DWORD PTR _pcchNewDestLength$
	mov	edx, DWORD PTR _cchNewDestLength$
	mov	DWORD PTR [ecx], edx
$LN1@StringCopy:
; Line 8978  **    if (SUCCEEDED(hres)) {
	mov	eax,  _hr$
	ret					; 00000014H
ChaineCopyWorker ENDP



ChaineVPrintfWorkerA	PROC  stdcall  uses esi edi ebx pszDest:DWORD,cchDest:DWORD,pcchNewDestLength:DWORD,pszFormat:DWORD,argList:DWORD
		LOCAL hr:DWORD,aiRet:SDWORD,cchMax:DWORD,cchNewDestLength:DWORD
; Line 9030  **    if (SUCCEEDED(hres)) {
	mov	hr , 0 
; Line 9033  **    if (SUCCEEDED(hres)) {
	mov	cchNewDestLength , 0 
; Line 9036  **    if (SUCCEEDED(hres)) {
	mov	eax,cchDest 
	sub	eax, 1
	mov	cchMax , eax 
	invoke	vsnprintf,pszDest,cchMax,pszFormat,argList
	mov	aiRet , eax 
; Line 9048  **    if (SUCCEEDED(hres)) {
	cmp	aiRet , 0 
	jl	SHORT $LN5@StringVPri
	mov	edx,aiRet 
	cmp	edx,cchMax 
	jbe	SHORT $LN6@StringVPri
$LN5@StringVPri:
; Line 9051  **    if (SUCCEEDED(hres)) {
	mov	eax,pszDest 
	add	eax,cchMax 
	mov	pszDest , eax 
; Line 9052  **    if (SUCCEEDED(hres)) {
	mov	ecx,pszDest 
	mov	BYTE PTR [ecx], 0
; Line 9054  **    if (SUCCEEDED(hres)) {
	mov	edx,cchMax 
	mov	cchNewDestLength , edx 
; Line 9057  **    if (SUCCEEDED(hres)) {
	mov	hr , -2147024774	; 8007007aH 
	jmp	SHORT $LN4@StringVPri
$LN6@StringVPri:
; Line 9059  **    if (SUCCEEDED(hres)) {
	mov	eax,aiRet 
	cmp	eax,cchMax 
	jne	SHORT $LN3@StringVPri
; Line 9062  **    if (SUCCEEDED(hres)) {
	mov	ecx,pszDest 
	add	ecx,cchMax 
	mov	pszDest , ecx 
; Line 9063  **    if (SUCCEEDED(hres)) {
	mov	edx,pszDest 
	mov	BYTE PTR [edx], 0
; Line 9065  **    if (SUCCEEDED(hres)) {
	mov	eax,cchMax 
	mov	cchNewDestLength , eax 
; Line 9067  **    if (SUCCEEDED(hres)) {
	jmp	SHORT $LN4@StringVPri
$LN3@StringVPri:
; Line 9069  **    if (SUCCEEDED(hres)) {
	mov	ecx,aiRet 
	mov	cchNewDestLength , ecx 
$LN4@StringVPri:
; Line 9072  **    if (SUCCEEDED(hres)) {
	cmp	pcchNewDestLength , 0 
	je	SHORT $LN1@StringVPri
; Line 9074  **    if (SUCCEEDED(hres)) {
	mov	edx,pcchNewDestLength 
	mov	eax,cchNewDestLength 
	mov	DWORD PTR [edx], eax
$LN1@StringVPri:
; Line 9077  **    if (SUCCEEDED(hres)) {
	mov	eax,hr 
	ret                   
ChaineVPrintfWorkerA ENDP


SendTo_SendToItem	PROC  C  uses esi edi ebx hwnd:DWORD,idm:DWORD
		LOCAL pdto:DWORD,pidl:DWORD,IDropT:DWORD,hres:SDWORD,mii:MENUITEMINFO,Isfolder:DWORD
	lea eax,g_szFileName
	mov pdto,0	
	invoke	GetUIObjectOfPath,hwnd,addr g_szFileName,addr IID_IDataObject,addr pdto
	.if pdto != 0 	
		mov	DWORD PTR mii.cbSize,sizeof mii	; 00000030H 
		mov	DWORD PTR mii.fMask,MIIM_DATA		; 00000020H 
		invoke	GetMenuItemInfoA,DWORD PTR g_hmenuSendTo,idm,0,addr mii
		.if eax != 0  && mii.dwItemData != 0
			mov	edx, mii.dwItemData 
			mov	pidl , edx 
			invoke	GetSpecialFolder,hwnd,CSIDL_SENDTO
			mov	Isfolder , eax 
			.if Isfolder != 0 
				COM Isfolder,GetUIObjectOf,hwnd, 1, addr pidl,\
						addr IID_IDropTarget, NULL,addr IDropT
				.if IDropT != 0
					invoke	DoDrop,pdto,IDropT
					COM IDropT,Release
				.endif
				COM Isfolder,Release											
			.endif
		.endif
		COM pdto,Release
	.endif
	ret  
SendTo_SendToItem ENDP

SendTo_OnCommand	PROC  C  uses esi edi ebx hwnd:DWORD,id:SDWORD,hwndCtl:DWORD,codeNotify:DWORD
; Line 528  **    if (id >= IDM_SENDTOFIRST && id <= IDM_SENDTOLAST) {
	cmp	id , 512		; 00000200H 
	jl	SHORT $LN3@SendTo_OnC@2
	cmp	id , 767		; 000002ffH 
	jg	SHORT $LN3@SendTo_OnC@2
	invoke	SendTo_SendToItem,hwnd,id
	jmp	SHORT $LN4@SendTo_OnC@2
$LN3@SendTo_OnC@2:
; Line 530  **    } else if (id == IDM_OPEN) {
	cmp	id , 256		; 00000100H 
	jne	SHORT $LN4@SendTo_OnC@2
	invoke	SendTo_OnOpen,hwnd
$LN4@SendTo_OnC@2:
	ret  
SendTo_OnCommand ENDP

SendTo_OnDestroy	PROC  C  uses esi edi ebx hwnd:DWORD
; Line 549  **    if (g_hmenuSendTo) {
	cmp	DWORD PTR g_hmenuSendTo,  0
	je	SHORT $LN1@SendTo_OnD
	invoke	SendTo_ResetSendToMenu,g_hmenuSendTo
$LN1@SendTo_OnD:
	invoke	PostQuitMessage,0
	ret  
SendTo_OnDestroy ENDP


SendTo_WndProc	PROC  stdcall  uses esi edi ebx hwnd:DWORD,uiMsg:DWORD,wParam:DWORD,lParam:DWORD
			Local id:SDWORD,hwndCtl:DWORD,codeNotify:DWORD
			Local hmenu:DWORD,item:DWORD,fSystemMenu:DWORD
			LOCAL tv64:DWORD
			
; Line 567  **    switch (uiMsg) {
	mov	eax,uiMsg 
	mov	tv64, eax
	cmp	tv64, 273		; 00000111H
	ja	SHORT $LN9@SendTo_Wnd
	cmp	tv64, 273		; 00000111H
	je	SHORT $LN3@SendTo_Wnd
	cmp	tv64, 1
	je	SHORT $LN4@SendTo_Wnd
	cmp	tv64, 2
	je	$LN1@SendTo_Wnd
	jmp	$LN5@SendTo_Wnd
$LN9@SendTo_Wnd:
	cmp	tv64, 279		; 00000117H
	je	SHORT $LN2@SendTo_Wnd
	jmp	$LN5@SendTo_Wnd
$LN4@SendTo_Wnd:
	invoke	SendTo_OnCreate,hwnd,lParam
	neg	eax
	sbb	eax, eax
	neg	eax
	sub	eax, 1
	jmp	$LN7@SendTo_Wnd
$LN3@SendTo_Wnd:
	;.elseif uMsg == WM_COMMAND
	;	HIWORD wParam,edx	;vnements des contrles edx
	;	LOWORD wParam,eax	;IDentificateurs de  commandes eax
	;	mov ebx,lParam	; handle du controle
		
	mov	eax,wParam
	shr	eax, 16					; 00000010H
	and	eax, 0ffffH
	movzx	ecx, ax
	mov codeNotify,ecx
	
	mov	edx, DWORD PTR lParam
	mov hwndCtl,edx
	
	mov	eax,wParam
	and	eax, 0ffffH				
	movzx	ecx, ax
	mov id,ecx
		
	invoke	SendTo_OnCommand,hwnd,id,hwndCtl,codeNotify
	xor	eax, eax
	jmp	SHORT $LN7@SendTo_Wnd
	;-------------------------------------------------------------
$LN2@SendTo_Wnd:
	;hwnd:DWORD,hmenu:DWORD,item:DWORD,fSystemMenu:DWORD
	mov	eax,lParam
	shr	eax, 16					; 00000010H
	and	eax, 65535				; 0000ffffH
	movzx	ecx, ax
	mov fSystemMenu,ecx
	
	mov	edx, DWORD PTR lParam
	and	edx, 65535				; 0000ffffH
	movzx	eax, dx	
	mov item,eax
	
	invoke	SendTo_OnInitMenuPopup,hwnd,wParam,item,fSystemMenu
	xor	eax, eax
	jmp	SHORT $LN7@SendTo_Wnd
$LN1@SendTo_Wnd:
	invoke	SendTo_OnDestroy,hwnd
	xor	eax, eax
	jmp	SHORT $LN7@SendTo_Wnd
$LN5@SendTo_Wnd:
	invoke	DefWindowProc,hwnd,uiMsg,wParam,lParam
$LN7@SendTo_Wnd:
	ret                   
SendTo_WndProc ENDP

InitApp	PROC  C  uses esi edi ebx 
		LOCAL hr:SDWORD,wc[40]:BYTE
; Line 596  **    wc.style = 0;
	mov	DWORD PTR wc [0], 0 
; Line 597  **    wc.lpfnWndProc = SendTo_WndProc;
	mov	DWORD PTR wc [+4],SendTo_WndProc
; Line 598  **    wc.cbClsExtra = 0;
	mov	DWORD PTR wc [+8], 0 
; Line 599  **    wc.cbWndExtra = 0;
	mov	DWORD PTR wc [+12], 0 
; Line 600  **    wc.hInstance = g_hinst;
	mov	eax, DWORD PTR g_hinst 
	mov	DWORD PTR wc [+16], eax 
; Line 601  **    wc.hIcon = NULL;
	mov	DWORD PTR wc [+20], 0 
	invoke	LoadCursorA,0,32512
	mov	DWORD PTR wc [+24], eax 
; Line 603  **    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	mov	DWORD PTR wc [+28], 6 
; Line 604  **    wc.lpszMenuName = TEXT("SendToMenu");
	mov	DWORD PTR wc [+32], OFFSET $SG120658 
; Line 605  **    wc.lpszClassName = TEXT("SendTo");
	mov	DWORD PTR wc [+36], OFFSET $SG120659 
	invoke	RegisterClassA,addr DWORD PTR wc [0] 
	invoke	SHGetDesktopFolder,addr ppvIShellFolder
	mov	hr , eax 
; Line 610  **    if (FAILED(hr)) {
	cmp	hr , 0 
	jge	SHORT $LN1@InitApp
; Line 611  **        return FALSE;
	xor	eax, eax
	jmp	SHORT $LN2@InitApp
$LN1@InitApp:
; Line 614  **    return TRUE;
	mov	eax, 1
$LN2@InitApp:
	ret  
InitApp ENDP

TermApp	PROC  C   
; Line 628  **    if (ppvIShellFolder) {
	cmp	DWORD PTR ppvIShellFolder,  0
	je	SHORT $LN2@TermApp
	IShellFolder Release
; Line 630  **        ppvIShellFolder = NULL;
	mov	DWORD PTR ppvIShellFolder,  0
$LN2@TermApp:
	ret  
TermApp ENDP


WinMain	PROC  stdcall  uses esi edi ebx hinst:DWORD,hinstPrev:DWORD,pszCmdLine:DWORD,nCmdShow:DWORD
		LOCAL hwnd:DWORD,msg[28]:BYTE,hrInit:SDWORD
; Line 651  **    g_hinst = hinst;
	mov	eax,hinst 
	mov	DWORD PTR g_hinst,  eax
	invoke	InitApp
	test	eax, eax
	jne	SHORT $LN4@WinMain
	xor	eax, eax
	jmp	$LN5@WinMain
$LN4@WinMain:
	invoke	CoInitialize,0
	mov	hrInit , eax 
	invoke	CreateWindowEx,0,addr $SG120688,addr $SG120687,13565952,-2147483648,-2147483648,-2147483648,-2147483648,0,0,hinst,0
	mov	hwnd , eax 
	invoke	ShowWindow,hwnd,nCmdShow
$LN3@WinMain:
	invoke	GetMessage,addr DWORD PTR msg [0] ,0,0,0
	test	eax, eax
	je	SHORT $LN2@WinMain
	invoke	TranslateMessage,addr DWORD PTR msg [0] 
	invoke	DispatchMessage,addr DWORD PTR msg [0] 
; Line 673  **    }
	jmp	SHORT $LN3@WinMain
$LN2@WinMain:
	invoke	TermApp
; Line 677  **    if (SUCCEEDED(hrInit))
	cmp	hrInit , 0 
	jl	SHORT $LN1@WinMain
	invoke	CoUninitialize
$LN1@WinMain:
; Line 680  **    return 0;
	xor	eax, eax
$LN5@WinMain:
	ret                   
WinMain ENDP


END

	
